<?php


class	d2p_manager
{
	var	$dbConn;
	var	$lastModifier;
	var	$requests;
	var	$cache;

	function	d2p_manager($connection)
	{
		$this->dbConn = $connection;
		$this->lastModifier = NULL;
		$this->requests = array();
		$this->cache = array();
	}

	function	newObject($type)
	{
		$tmp = NULL;
		$instr = '$tmp = new d2p_cl_' . $type . '($this, NULL);';
		eval($instr);
		if	(is_object($tmp) && is_a($tmp, "d2p_cl_$type"))
			return	$tmp;
		elseif	(is_object($tmp))
			unset($tmp);
		return	NULL;
	}

	function	objectFromBase($type, $identifier)
	{
		if	(is_object($this->cache[$type][$identifier]))
			return	$this->cache[$type][$identifier];

		$tmp = NULL;
		$instr = '$tmp = new d2p_cl_' . $type . '($this, $identifier);';
		eval($instr);
		if	(is_object($tmp) && is_a($tmp, "d2p_cl_$type"))
		{
			if	(!is_array($this->cache[$type]))
				$this->cache[$type] = array();
			$this->cache[$type][$identifier] = &$tmp;
			return	$tmp;
		}
		elseif	(is_object($tmp))
			unset($tmp);
		return	NULL;
	}

	function	listFromBase($type, $request)
	{
		$tmp = NULL;
		$instr = '$tmp = new d2p_cl_' . $type . '($this, NULL);';
		eval($instr);
		if	(!(is_object($tmp) && is_a($tmp, "d2p_cl_$type")))
		{
			unset($tmp);
			return	NULL;
		}
		$name = $tmp->getIdentifierName();
		unset($tmp);

		$result = @pg_query($this->dbConn, $request);
		if	(!$result)
			return	NULL;

		$tab = array();
		while	($row = pg_fetch_array($result))
		{
			$tmp = $this->objectFromBase($type, $row[$name]);
			if	(!is_null($tmp))
				array_push($tab, $tmp);
		}
		pg_free_result($result);

		if	(!count($tab))
			return	NULL;

		return	$tab;
	}

	function	getDatabaseConnection()
	{
		return	$this->dbConn;
	}

	function	objectModified(&$object)
	{
		if	(!($object && is_object($object) && is_a($object, "d2p_data")))
			return	false;

		if	(! $this->lastModifier || ($this->lastModifier->getObjId() != $object->getObjId()))
		{
			if	($this->lastModifier)
			{
				$req = $this->lastModifier->createRequest();
				if	($req != "")
				{
					if	(preg_match("/^DELETE /", $req))
						unset($this->lastModifier);
					else
						$this->lastModifier->isValid();
					array_push($this->requests, $req);
				}
			}
			$this->lastModifier = &$object;
		}

		return	true;
	}

	function	commit()
	{
		if	($this->lastModifier)
		{
			$req = $this->lastModifier->createRequest();
			if	($req != "")
			{
				if	(preg_match("/^DELETE /", $req))
					unset($this->lastModifier);
				else
					$this->lastModifier->isValid();
				array_push($this->requests, $req);
				$this->lastModifier = NULL;
			}
		}

		if	(count($this->requests) == 0)
			return	true;

		if	(!@pg_query($this->dbConn, "BEGIN TRANSACTION"))
			return	false;
		foreach ($this->requests as $req)
		{
			if	(!@pg_query($this->dbConn, $req))
			{
				@pg_query($this->dbConn, "ROLLBACK TRANSACTION");
				return	false;
			}
		}
		if	(!@pg_query($this->dbConn, "COMMIT"))
			return	false;

		$this->requests = array();
		$this->lastModifier = NULL;
		return	true;
	}
}


?>
